	/**
	 * Convert an InputStream to a string.
	 * http://stackoverflow.com/a/309718
	 * @param is
	 * @param bufferSize
	 * @return
	 * @throws IOException 
	 */
	public static String slurp(final InputStream is, final int bufferSize) throws IOException
	{
	  final char[] buffer = new char[bufferSize];
	  final StringBuilder out = new StringBuilder();
	    final Reader in = new InputStreamReader(is, "UTF-8");
	    try {
	      for (;;) {
	        int rsz = in.read(buffer, 0, buffer.length);
	        if (rsz < 0)
	          break;
	        out.append(buffer, 0, rsz);
	      }
	    }
	    finally {
	      in.close();
	    }
	  return out.toString();
}