	public TripLine(TrafficEdge te, int type, ProjectedCoordinate p1, ProjectedCoordinate p2, double lineLength)
	{
		// calc normal to p1-p2 at tp of lineLength 
		// http://stackoverflow.com/questions/7469959/given-2-points-how-do-i-draw-a-line-at-a-right-angle-to-the-line-formed-by-the-t/7470098#7470098
	
		parentEdge = te;
		tripLineType = type;
		
		Vector v1 = GeoUtils.getVector(p1);
		Vector v2 = GeoUtils.getVector(p2);
		
		Vector dV = v2.minus(v1);
	
		Vector rN = VectorFactory.getDefault().createVector2D(dV.getElement(1), -dV.getElement(0));
		Vector lN = VectorFactory.getDefault().createVector2D(-dV.getElement(1), dV.getElement(0));
		
		Vector uR = rN.unitVector();
		Vector uL = lN.unitVector();
		
		tpV1 = v1.plus(uL.scale(lineLength/2));
		tpV2 = v1.plus(uR.scale(lineLength/2));
				
		Coordinate[] coords = {GeoUtils.convertToProjectedCoordinate(p1.getTransform(), tpV1, p1.getReferenceLatLon()), GeoUtils.convertToProjectedCoordinate(p1.getTransform(), tpV2, p1.getReferenceLatLon())};
		
		geom = GeoUtils.projectedGeometryFactory.createLineString(coords);
		
		Coordinate[] coordsLonLat = {GeoUtils.convertToLonLat(tpV1, p1.getTransform()), GeoUtils.convertToLonLat(tpV2, p1.getTransform())};
		
		geomLonLat = GeoUtils.geometryFactory.createLineString(coordsLonLat);
}