
  /**
   * Over engineered. There are <a href="http://stackoverflow.com/a/442773">pitfalls</a> to this method of getting a
   * {@code StackTraceElement}'s index which this method does not address. I make a best guess based upon development
   * environment testing.
   *
   * @see <a href="http://stackoverflow.com/a/8592871">Getting the name of the current executing method</a>
   */
  private static final int CLIENT_CODE_STACK_INDEX;

  static {
        /*
         Finds out the index of "this code" in the returned stack trace - funny but it differs in JDK 1.5, and 1.6.
         In my tests I had to modify to get to work in 1.7 and 1.8.
        */
    int i = 0;
    for (StackTraceElement ste : Thread.currentThread().getStackTrace()) {
            /* original placement of increment via SO
            i++;
             */
      if (ste.getClassName().equals(PreferencesHelperTest.class.getName())) {
        break;
      }
      i++;//My placement of increment via environmental testing.
    }
    CLIENT_CODE_STACK_INDEX = i;
}