    /**
     * Unclosable output stream.
     *
     * Avoid passing System.out directly to HTSJDK, because it will close it at the end.
     *
     * http://stackoverflow.com/questions/8941298/system-out-closed-can-i-reopen-it/23791138#23791138
     */
    public static class UnclosableOutputStream extends FilterOutputStream {

        public UnclosableOutputStream(OutputStream os) {
            super(os);
        }

        @Override
        public void close() throws IOException {
            super.flush();
        }
}