	@Override
	public int onStartCommand (Intent intent, int flags, int id)
	{
		if (intent != null) // http://stackoverflow.com/a/20686768/521361 //
		{
			LinearLayout llLauncherPinnedApps = (LinearLayout) this.llLauncher.findViewById (R.id.llLauncherPinnedApps);

			if (intent.getBooleanExtra ("start", false))
			{
				be.robinj.distrohopper.unity.launcher.AppLauncher lalBfb = (be.robinj.distrohopper.unity.launcher.AppLauncher) this.llLauncher.findViewById (R.id.lalBfb);
				lalBfb.init ();

				this.chameleonicBgColour = intent.getIntExtra ("bgColour", Color.argb (40, 40, 40, 40));

				this.llLauncher.setBackgroundColor (this.chameleonicBgColour);
				lalBfb.setColour (intent.getIntExtra ("colour", Color.argb (40, 40, 40, 40)));

				List<App> pinned = intent.getParcelableArrayListExtra ("pinned");
				llLauncherPinnedApps.removeAllViews ();

				for (App app : pinned)
				{
					app.fixAfterUnpackingFromParcel (this);
					AppLauncher appLauncher = new AppLauncher (this, app);

					appLauncher.setOnClickListener (new AppLauncherClickListener ());
					appLauncher.setTag (app.getPackageName () + "\n" + app.getActivityName ());

					llLauncherPinnedApps.addView (appLauncher);
				}

				this.pinned = pinned;
			}

			this.layout.setVisibility (intent.getBooleanExtra ("show", true) ? View.VISIBLE : View.GONE);
			if (! intent.getBooleanExtra ("visible", false))
				this.swipeLeft ();

			for (int i = 0; i < llLauncherPinnedApps.getChildCount (); i++)
				((AppLauncher) llLauncherPinnedApps.getChildAt (i)).setRunning (false);

			List<App> running = intent.getParcelableArrayListExtra ("running");
			if (running != null)
			{
				LinearLayout llLauncherRunningApps = (LinearLayout) this.llLauncher.findViewById (R.id.llLauncherRunningApps);
				llLauncherRunningApps.removeAllViews ();

				for (App app : running)
				{
					app.fixAfterUnpackingFromParcel (this);

					if (this.isPinned (app))
					{
						AppLauncher appLauncher = (AppLauncher) llLauncherPinnedApps.findViewWithTag (app.getPackageName () + "\n" + app.getActivityName ());
						appLauncher.setRunning (true);
					}
					else
					{
						RunningAppLauncher appLauncher = new RunningAppLauncher (this, app);

						appLauncher.setOnClickListener (new AppLauncherClickListener ());
						appLauncher.setColour (this.chameleonicBgColour);

						llLauncherRunningApps.addView (appLauncher);
					}
				}
			}
		}

		return super.onStartCommand (intent, flags, id);
	}
