	/**
	 * @param map      a map
	 * @param location a location
	 * @return whether we needs a different color to show a non-top fixture there (like a
	 * forest or mountain)
	 */
	private boolean needsFixtureColor(final IMapNG map, final Point location) {
		if (hasTerrainFixture(map, location)) {
			final TileFixture topFixture = getTopFixture(map, location);
			// getLast() equivalent from http://stackoverflow.com/a/21441634
			final Optional<TileFixture> bottomTerrain = getDrawableFixtures(map,
					location).filter(TerrainFixture.class::isInstance).reduce(
					(first, second) -> second);
			return bottomTerrain.isPresent() && !topFixture.equals(bottomTerrain.get());
		} else {
			return false;
		}
}