  /**
   * Changes the annotation value for the given key of the given annotation to newValue and returns
   * the previous value. Modified from http://stackoverflow.com/a/28118436
   * @param annotation the {@link QueryFile} annotation applied to the test method
   * @param key a {@link String} equal to {@code "list"}
   * @param newValue a {@link String} containing a comma-separated list of test files 
   * @return the old value of the annotation, which should be an empty {@link String} array
   */
  @SuppressWarnings("unchecked")
  public static Object changeAnnotationValue(Annotation annotation, String key, Object newValue){
      Object handler = Proxy.getInvocationHandler(annotation);
      Field f;
      try {
          f = handler.getClass().getDeclaredField("memberValues");
      } 
      catch (NoSuchFieldException e)
      {
         throw new IllegalStateException(e);
      }
      catch (SecurityException e) 
      {
        throw new IllegalStateException(e);
      }
      f.setAccessible(true);
      Map<String, Object> memberValues;
      try {
          memberValues = (Map<String, Object>) f.get(handler);
      } 
      catch (IllegalArgumentException e) 
      {
        throw new IllegalStateException(e);
      }
      catch (IllegalAccessException e) 
      {
          throw new IllegalStateException(e);
      }
      Object oldValue = memberValues.get(key);
      memberValues.put(key,newValue);
      return oldValue;
}