    private void spawnUnitForCity(Position pos, Player owner, String type) {
        // Adapted from http://stackoverflow.com/a/3706260/553294
        // (di, dj) is a vector - direction in which we move right now
        int dr = -1;
        int dc = 0;
        // length of current segment
        int segment_length = 1;

        // current position (i, j) and how much of current segment we passed
        int row = 0;
        int col = 0;
        int segment_passed = 0;
        for (int k = 0; k < GameConstants.WORLDSIZE * GameConstants.WORLDSIZE; ++k) {
            Position testPos = new Position(pos.getRow() + row, pos.getColumn() + col);
            if (trySpawnUnitAt(owner, type, testPos))
                return;

            // make a step, add 'direction' vector (dr, dc) to current position (i, j)
            row += dr;
            col += dc;
            ++segment_passed;

            if (segment_passed == segment_length) {
                // done with current segment
                segment_passed = 0;

                // 'rotate' directions
                int temp = -dr;
                dr = dc;
                dc = temp;

                // increase segment length if necessary
                if (dc == 0) {
                    ++segment_length;
                }
            }
        }
}