
/**
 * @author Dominik Szalai - emptulik at gmail.com on 4/19/16.
 * @see CustomTransactionExecutorFactory
 */
@Log4j2
@Component
public class CustomTransactionExecutorImpl implements CustomTransactionExecutor
{
    @Autowired
    private PlatformTransactionManager platformTransactionManager;

    // http://stackoverflow.com/a/18790494/1203690
    @Override
    public <T> T executeOutsideTransactionalAnnotation(TransactionCallback<T> transactionCallback)
    {
        return new TransactionTemplate(platformTransactionManager).execute(transactionCallback);
    }

}