	/**
	 * Decodes a previously encoded {@code Days} to new instance with the same values 
	 * @param encodedValue - the value generated by {@code Days.encode()}
	 * @return a decoded days.
	 * @see <a href="http://stackoverflow.com/a/2199693">Inspired by</a>
	 */
	public static Days decode(int encodedValue) {
        Weekday[] values = Weekday.values();
        EnumSet<Weekday> result = EnumSet.noneOf(Weekday.class);
        
        while (encodedValue != 0) {
            int ordinal = Integer.numberOfTrailingZeros(encodedValue);
            
            // Prepare next ordinal
            encodedValue ^= Integer.lowestOneBit(encodedValue);
            result.add(values[ordinal]);
        }
        return new Days(result);
}