    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        Toolbar toolbar = (Toolbar)findViewById(R.id.toolbar);
        setSupportActionBar(toolbar);

        ListView listView = (ListView)findViewById(R.id.listView);
        listView.setAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, m_ListData));

        ParsePush.subscribeInBackground(PUSH_CHANNEL);

        // Request permission for Android API level >= 23.
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M) {
            for (int i = 0; i < PERMISSIONS.length; i++) {
                if (this.checkSelfPermission(PERMISSIONS[i]) != PackageManager.PERMISSION_GRANTED) {
                    this.requestPermissions(PERMISSIONS, 0);
                    break;
                }
            }
        }

        m_BeaconM = BeaconManager.getInstanceForApplication(this);
        // Add parser for iBeacon.
        m_BeaconM.getBeaconParsers().add(
                new BeaconParser().setBeaconLayout("m:2-3=0215,i:4-19,i:20-21,i:22-23,p:24-24")
        );
        // http://stackoverflow.com/a/25521588
        RangedBeacon.setSampleExpirationMilliseconds(6000);
        m_BeaconM.bind(this);

        m_RangeNotifier = new MyRangeNotifier();
}