    private List<Predicate> getPredicates(CriteriaBuilder criteriaBuilder, Root<Person> root) {
        List<Predicate> result = new ArrayList<>();

        if (id != null) {
            // satrapu - 2015-10-18: perform LIKE over an integer value - see http://stackoverflow.com/a/10230847
            result.add(criteriaBuilder.like(root.get(Person_.id).as(String.class), MessageFormat.format("%{0}%", id)));
        }

        if (!StringExtensions.isNullOrWhitespace(firstNamePattern)) {
            result.add(criteriaBuilder.like(criteriaBuilder.lower(root.get(Person_.firstName)),
                    MessageFormat.format("%{0}%", firstNamePattern.toLowerCase())));
        }

        if (!StringExtensions.isNullOrWhitespace(middleNamePattern)) {
            result.add(criteriaBuilder.like(criteriaBuilder.lower(root.get(Person_.middleName)),
                    MessageFormat.format("%{0}%", middleNamePattern.toLowerCase())));
        }

        if (!StringExtensions.isNullOrWhitespace(lastNamePattern)) {
            result.add(criteriaBuilder.like(criteriaBuilder.lower(root.get(Person_.lastName)),
                    MessageFormat.format("%{0}%", lastNamePattern.toLowerCase())));
        }

        if (!StringExtensions.isNullOrWhitespace(emailAddressNamePattern)) {
            result.add(criteriaBuilder.like(criteriaBuilder.lower(root.get(Person_.emailAddress)),
                    MessageFormat.format("%{0}%", emailAddressNamePattern.toLowerCase())));
        }

        return result;
}